#!/bin/bash

function toppage() {
    cat <<EOF
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<html><head><title>
EOF
    echo $1"</title></head><body>"
}

function mainpage() {
    toppage "Graphikos Sus Tekhnikos"
    cat heading.html
    
    echo "<p>"
    
    for path in *; do
	if [ -d $path ] && [ $path != "." ] && [ $path != ".." ]; then
	    echo "<h3><a href=\"$thispage?album=$path\" target=\"_self\">$path</a></h3>"
	fi
    done
    
    cat footer.html
    echo "</body></html>"
}

function albumpage() {
    
# Don't just eval $QUERY_STRING, it's potentially dangerous!
    for path in *; do 
	if [ -d $path ] && [ "$QUERY_STRING" == "album=$path" ]; then
	    eval $QUERY_STRING
	fi
    done

    toppage $album
    echo "<center>"
    
    cat $album/heading.html
    
    echo "<p>"
    
    for path in $album/small/*.$EXT; do
	image=`basename $path`
	echo "<a href=\"$album/large/$image\" target=\"_blank\"><img src=\"$path\" border=0 alt=\"$image\"></a><br><br><br>"
    done

    echo "<a href=\"$thispage\" target=\"_self\">Back to gallery main page</a>"
    
    echo "</center></body></html>"
}

EXT=jpeg
thispage=`basename $0`

if [ $QUERY_STRING ]; then
    albumpage
else
    mainpage
fi